VERSION 5.00
Object = "{95C1F41F-ED63-433B-ACDB-D6B5BE6D3566}#7.0#0"; "GP3.ocx"
Begin VB.Form OScope 
   Caption         =   "OScope"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9420
   LinkTopic       =   "Form1"
   ScaleHeight     =   361
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   628
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3120
      Top             =   4800
   End
   Begin AWCGP3.GP3IO IO 
      Height          =   375
      Left            =   600
      TabIndex        =   1
      Top             =   4800
      Width           =   855
      _ExtentX        =   1508
      _ExtentY        =   661
      CommPort        =   7
   End
   Begin VB.PictureBox OScreen 
      BackColor       =   &H00000000&
      ForeColor       =   &H0000FF00&
      Height          =   4455
      Left            =   120
      ScaleHeight     =   293
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   613
      TabIndex        =   0
      Top             =   120
      Width           =   9255
   End
End
Attribute VB_Name = "OScope"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub Sleep Lib "kernel32" (ByVal tm As Long)
Dim Grid As Boolean  ' grid on/off
Dim xpos As Integer  ' current x
Dim xmax As Integer  ' max x
Dim ymax As Integer  ' max y
Dim xlast As Integer ' laxt x/y
Dim ylast As Integer
Dim sstring As String ' input string
Dim quit As Boolean

Private Sub Form_GotFocus()  ' force focus for keyboard cmds
OScreen.SetFocus
End Sub

Private Sub Form_Load()   ' Initial setup
Grid = True
CommStart
End Sub


Private Sub Form_Resize()   ' fill window with scope image
OScreen.Top = 0
OScreen.Left = 0
OScreen.Width = OScope.ScaleWidth
OScreen.Height = OScope.ScaleHeight
xmax = OScreen.ScaleWidth
ymax = OScreen.ScaleHeight
OClear   ' clear screen so we don't have wierd results
End Sub

Private Sub Form_Unload(Cancel As Integer)  ' Done
CommStop
End
End Sub

' Show commands
Private Sub OScreen_Click()
Commands.Show vbModal
End Sub

' Handle keyboard commands
Private Sub OScreen_KeyPress(KeyAscii As Integer)
If (KeyAscii = Asc("S") Or KeyAscii = Asc("s")) And IO.PortOpen Then
  CommStop
End If
If (KeyAscii = Asc("R") Or KeyAscii = Asc("r")) And Not IO.PortOpen Then
  CommStart
End If
If (KeyAscii = Asc("C") Or KeyAscii = Asc("c")) Then
  Clipboard.Clear
  CopyEntirePicture OScreen
End If
If (KeyAscii = Asc("G") Or KeyAscii = Asc("g")) Then
  Grid = Not Grid
  DoGrid
End If
If (KeyAscii = Asc("K") Or KeyAscii = Asc("k")) Then
  Dialog.Show vbModal
End If
End Sub

' Clear screen and reset parameters
Private Sub OClear()
OScreen.Cls
DoGrid
xpos = 0
xlast = -1
ylast = -1
End Sub

' draw grid
Public Sub DoGrid()
If Not Grid Then Exit Sub
Dim x As Integer
Dim y As Integer
Dim oldcolor
oldcolor = OScreen.ForeColor
OScreen.ForeColor = &H808080
For x = 0 To xmax Step xmax / 10
 OScreen.Line (x, 0)-(x, ymax)
Next
For y = 0 To ymax Step ymax / 10
 OScreen.Line (0, y)-(xmax, y)
Next
OScreen.ForeColor = oldcolor
End Sub

' Shutdown com port
Public Sub CommStop()
If IO.PortOpen = True Then
  IO.PortOpen = False
  quit = True
End If
End Sub

' Start com port
Public Sub CommStart()
quit = False
Form_Resize
On Error Resume Next
IO.PortOpen = True
If Err.Number <> 0 Then
  MsgBox "Can't open Com Port"
End If
End Sub

' Do a command from external source
Public Sub cmd(s As String)
OScreen_KeyPress Asc(s)
End Sub

Private Sub Timer1_Timer()
    Static busy
    Dim n
    If busy Or Not IO.PortOpen Then Exit Sub
    busy = True
    OClear
    IO.repeat xmax + 1
    n = IO.a2d(0)
    For xpos = 0 To xmax
    If quit Then
       busy = False
       Exit Sub
    End If
    ' n between 0 and 1023
    Dim y As Single
    Dim volt As Single
    Dim yint As Integer
    y = ymax
    y = y * n / 1024
    If xpos Mod 64 = 0 Then
      volt = (n / 1024#) * 5
      OScope.Caption = "Last = " & Format(volt, "0.00") & "V"
    End If
    yint = ymax - Int(y)
    If xlast <> -1 Then OScreen.Line (xlast, ylast)-(xpos, yint)
    xlast = xpos
    ylast = yint
    If xpos <> xmax Then n = IO.readword
    Next
    busy = False
End Sub
